package net.thecodersbreakfast.spring.pluginsystem;

import java.util.Map;

import net.thecodersbreakfast.spring.pluginsystem.plugin.IPlugin;

import org.springframework.context.support.ClassPathXmlApplicationContext;

/**
 * 
 */
public class Main
{
	public static void main(String[] args)
	{
		// Recherche des plugins
		ClassPathXmlApplicationContext springContext = new ClassPathXmlApplicationContext("spring.xml");
		Map<String, IPlugin> plugins = springContext.getBeansOfType(IPlugin.class);

		// Enregistrement auprs du PluginManager
		PluginManager manager = new PluginManager();
		for (IPlugin plugin : plugins.values())
		{
			manager.addPlugin(plugin);
		}

		// Utilisation des plugins
		for (IPlugin plugin : manager.getPlugins())
		{
			System.out.println("\nPlugin : " + plugin.getId());
			plugin.run();
		}
	}
}
